SOGo | BTS

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0000633Funambol SOGo Connectorpublic2010-05-27 21:092012-03-18 07:16
Reporterwcronen 
Assigned To 
PrioritynormalSeveritymajorReproducibilityalways
StatusfeedbackResolutionopen 
PlatformOSOS Version
Product Version 
Target VersionFixed in Version 
Summary0000633: Alarms aren't synced correctly. Conversion necessary!
DescriptionI investigated some time looking for a working event alarm synchronisation.

The problem is that neither SOGo nor Lightning have implemented the full iCalendar standard. For event alarms this means:
SOGo+Lightning only support RELATIV but not ABSOLUTE/FIXED alarm times.

Most, if not ALL, mobile phones on the other hand only seem to support ABSOLUTE alarms.

A good working solution would be to save VCALENDAR entries in the SOGo database with relativ alarms.
The funambol-connector should then convert this relativ alarm to an absolute alarm before syncing it to mobile devices and vice versa.

With this solution the alarms would be working as should in SOGO,Lightning and all mobile devices which are synced with Funambol.

A relativ alarms in iCalendar looks something like:
BEGIN:VALARM
ACTION:DISPLAY
TRIGGER;VALUE=DURATION:-PT30M
DESCRIPTION:Test
END:VALARM

An absolut/fixed alarm:
BEGIN:VALARM
ACTION:DISPLAY
TRIGGER;VALUE=DATE-TIME:20100423T070000Z
DESCRIPTION:Test
END:VALARM
Additional InformationAs I don't know enough about the internals of the funambol connector I can't program a solution but I found working converters for funambol and lightning.

I hope that with these 2 files it's not too difficult to implement the conversion because working alarms would be really great.

The files are part of the funambol server and are located in:
/opt/Funambol/config/com/funambol/server/engine/pipeline/phones-support/bsh/MozillaSyncClientout.bsh
and
/opt/Funambol/config/com/funambol/server/engine/pipeline/phones-support/bsh/MozillaSyncClientin.bsh

If needed I can also upload the files.

Hope that helps.
TagsNo tags attached.
Attached Files? file icon funambol-sogo-1.0.8.s4j [^] (74,517 bytes) 2010-11-12 12:02
xls file icon sogo-sync-edit.xls [^] (101,888 bytes) 2010-11-29 11:44

- Relationships Relation Graph ] Dependency Graph ]
has duplicate 0001127resolvedludovic SOGo Alarm not sync with funambol 
has duplicate 0000877new SOGo Task dialog in web-interface does not honor VALARMs with DATE-TIME 
has duplicate 0001375new Funambol SOGo Connector Reminders 
has duplicate 0000586resolvedwsourdeau SOGo Event alarms with a fixed time doesn't show in the web interface 
has duplicate 0000825closedludovic Funambol SOGo Connector reminder not synced with funambol sync plugin 0.9.1 for thunderbird 2 

-  Notes
(0001060)
havardw (reporter)
2010-05-28 05:45

As you said, SOGo doesn't implement the full iCalendar standard, so I think this should be fixed in main SOGo and not in the connector. I've already filed bug 586 about this.

Lightning 1.0 doesn support alarms with fixed times, as you can see in the other bug I used Lightning to create one.
(0001066)
wcronen (reporter)
2010-05-28 15:32

@havard:
I know your bug report but I think it's something different.

It's right that SOGo should implement the full iCalendar standard. That would be the optimal solution.
But I think it's much more work than to implement the converts which you could directly take from the 2 mentioned files and must only adopt a little bit for SOGo.

Another problem would be that without the converter events in Lightning wouldn't be shown correctly. Therefore Lightning must implement the full iCalendar standard also.

And last but not least:
Without the converter events on mobile devices wouldn't show correctly as most (all?) mobiles seem to support only absolut alarms.

The fast and only working solution for all this is:
VALARM-Converters in Funambol-SOGo-Connector

The full iCalendar standard in SOGo would be also very nice. But that should be another feature request (and the solution for your bug report 586).
(0001090)
wcronen (reporter)
2010-06-02 19:13

As nobody seems to be able to do it or have time for it, I'll try it myself.
Don't expect too much.

If I get the conversion running I'll make a patch and provide it here.
(0001440)
jaywalker (reporter)
2010-09-14 13:38

Please fix this bug, it is the only reason why I continue to use Horde instead of migrating to SOGo.
Unfortunately I cannot implement a solution myself, but I am willing to help otherwise.
(0001442)
wcronen (reporter)
2010-09-14 14:32

Yes, I'd also be very glad if this problem would be fixed and we could use Funambol-Sync.

I tried myself but aren't good enough in programming :(

As soon as there's a testing version I'd be glad to test it. I'd also test and try a new subversion trunk release.
User avatar (0001751)
ludovic (administrator)
2010-11-10 12:19

I think we really need to convert relative alarms to absolute ones when downgrading vcal 2 to vcal 1. I can't find any reference of relative alarms support in vcal 1.

Futhermore, with the v8.7 of the Funambol BlackBerry client, it now uses vcal 1 instead of SIF-E for events.

When an event is returned that contains a relative AALARM, it'll be skipped by the client because of incorrectly input data.
User avatar (0001770)
ludovic (administrator)
2010-11-11 15:55

I've pushed a fix for this - see:

https://sogo-connector.forge.funambol.org/source/browse/sogo-connector/trunk/src/java/ca/inverse/sogo/engine/source/SOGoUtilities.java?view=diff&pathrev=48&r1=47&r2=48 [^]

You can grab the Funambol SOGo Connector from SVN if you want to test it.

Basically, it'll convert relative alarms to absolute ones.
User avatar (0001779)
ludovic (administrator)
2010-11-12 09:05

Can any of you guys test my fix from yesterday?
(0001784)
jaywalker (reporter)
2010-11-12 12:00

Thank you for making a fix available! Unfortunately, I have no idea how to build the funambol sogo connector package from the svn sources. Could you perhaps give a short description of the download and build process, or even better make the .s4j-file available? Thank you!
User avatar (0001786)
ludovic (administrator)
2010-11-12 12:02

I've uploaded a s4j for testing.
(0001787)
wcronen (reporter)
2010-11-12 13:33

Many thx. I'm waiting for my new android and will test it as soon as possible and report any issues.
(0001796)
jaywalker (reporter)
2010-11-13 03:23

I tested on Nokia S60 mobile. Synchronization of events from Sogo to mobile seems to work, reminders stay intact. For whole-day events, the mobile displays an absolute alarm time, for normal events, the mobile re-translates the absolute alarm into a relative setting in its display. This is fine.

However, synchronization of events created on the mobile to sogo does not work: Alarms are lost, and for one event, I can see the event in sogos web interface, but when double-clicking on it, "An error occurred during object publishing
the requested object could not be found!" appears (this was a repeating event, and not synced to the default calendar, but to a different one).

The sync tag used to be displayed in the event name on the syncml client. This changed, and the sync tags of events created in sogo are no longer displayed on the mobile.
User avatar (0001797)
ludovic (administrator)
2010-11-13 07:52

Synchronization of events created on phones (that are absolute) will cause issue, this is issue 0000586.

As for the sync tag issue, I'm not sure I understand - please elaborate.
(0001798)
jaywalker (reporter)
2010-11-13 08:26

The sync tag issue:

If a user has two calendars, the standard personal calendar and another one called e.g. "test" (sync tag "t"), creates an event "meeting" in test and syncs it to the mobile, it used to show up there as "[t] meeting", indicating which calendar the item belongs to.
With the current version of the funambol connector, the event shows up as "meeting" on the mobile, the sync tag is no longer added to the event name.

Creating an event with name "[t] meeting" on the mobile and syncing it back to sogo creates the event in calendar "test" instead of the personal calendar. With the current connector, this still works, but at least sometimes, the event can not be opened or modified from the web interface. It appears in the overview (standard calendar view) in calendar "test", but cannot be opened. Instead, the error message "An error occured during object publishing. the requested object could not be found!" appears.
User avatar (0001843)
ludovic (administrator)
2010-11-16 13:49

I cannot reproduce the tag issue nor the "An error occured during object publishing. the requested object could not be found!" error.
(0001864)
wcronen (reporter)
2010-11-17 18:01

I don't have this problem with tags. Multiple calenders are synced great. What doesn't work are read-only calenders from groups but that's another problem.


These are the results of my test with svn_50 version of funambol-connector:

One good news and a bad one.

Good one:
Alarms work great on sogo-web and mobile if you create a new event with alarm and sync this event.

Bad one:
Editing the alarm of an existing event doesn't work neither on sogo-web nor mobile.
If you edit the alarm on mobile and sync it you still see the alarm clock in sogo-web but if you enter the event it says: "No reminder" :(
If you edit the alarm in web-interface and sync it to mobile you still see the previous alarm time.
User avatar (0001865)
ludovic (administrator)
2010-11-17 18:04

As for "If you edit the alarm on mobile and sync it you still see the alarm clock in sogo-web but if you enter the event it says: "No reminder" :(", that's 0000586

As for "If you edit the alarm in web-interface and sync it to mobile you still see the previous alarm time.", that might be a bug in your mobile device. Look at the ds-server.log to see if the alarm is being updated. If so, like my testing showed, then it's a bug in your mobile device.
(0001885)
wcronen (reporter)
2010-11-22 14:28

ok. I'll try it with outlook and funambol-plugin and report if it works better than with my mobile.
(0001895)
dusanl (reporter)
2010-11-25 10:07

Hi, I've tested this (funambol-sogo-1.0.8.s4j (74,517 bytes) 2010-11-12 12:02) plugin.
And now I'm able to sync the reminder from the sogo web client and thunderbird to the outlook and my windows mobile 6.5 phone.
- sogo->funambol->outlook/mda = work
But when I created the event with alarm (15 min. before) in the outlook or windows mobile 6.5 phone, I can see a event with reminder in the thunderbird, not like "15 min. before", but like "other" with correct time. But in the SOGo web client I still see "no reminder".
- outlook/mda->funambol->sogo(web) = noreminder
- outlook/mda->funambol->sogo(thunderbid) = work (but how "other" not like "15min. before)

configuration:
- sogo server 1.3.4 (64bit)
- funambol server 8.7 (64bit)
- thunderbird 3.1.6 (sogo extensions xy.104)
- outlook 2007 (funambol outlook sync client 9.0.20101026 - because of resolved bug with repeated events)
- htc hd2 (windows mobile 6.5) (funambol sync client v.8.7.2)
(0001898)
wcronen (reporter)
2010-11-25 15:20

@dusanl: What about editing existing events?

Try to edit an event created on webinterface/thunderbird/mobile and outlook.
Edit it on all your platforms and sync it then report if it works.

Editing was a major problem for me! Creating new works relative good.
(0001900)
dusanl (reporter)
2010-11-29 11:44

@wcronen: hi, so, I have tested editing existing events... And my resuls are attached here in "sogo-sync-edit.xls" file.

or here: :)
CREATED;sync_status;EDIT_REMINDER;sync_(edit)_status
WEB;tb(ok),outlook(ok),mda(ok);TB;web(ok),outlook(ok),mda(ok)
WEB;tb(ok),outlook(ok),mda(ok);OUTLOOK;web(without_reminder),tb(old_reminder-no_changes),mda(ok)
WEB;tb(ok),outlook(ok),mda(ok);MDA;web(without_reminder),tb(old_reminder-no_changes),outlook(old_reminder-no_changes)

TB;web(ok),outlook(ok),mda(ok);WEB;tb(ok),outlook(ok),mda(ok)
TB;web(ok),outlook(ok),mda(ok);OUTLOOK;tb(old_reminder-no_changes),web(without_reminder),mda(old_reminder-no_changes)
TB;web(ok),outlook(ok),mda(ok);MDA;tb(old_reminder-no_changes),web(without_reminder),outlook(old_reminder-no_changes)

OUTLOOK;web(without_reminder),tb(other_reminder-not_like_5min.before),mda(ok);TB;outlook(ok),web(ok),mda(ok)
OUTLOOK;web(without_reminder),tb(other_reminder-not_like_5min.before),mda(ok);WEB;outlook(ok),tb(ok),mda(ok)
OUTLOOK;web(without_reminder),tb(other_reminder-not_like_5min.before),mda(ok);MDA;outlook(ok),tb(old_reminder-no_changes),web(without_reminder)

MDA;web(without_reminder),tb(other_reminder-not_like_5min.before),outlook(ok);web;mda(ok),tb(ok),outlook(ok)
MDA;web(without_reminder),tb(other reminder-not_like_5min.before),outlook(ok);TB;mda(ok),web(ok),outlook(ok)
MDA;web(without_reminder),tb(other_reminder-not_like_5min.before),outlook(ok);OUTLOOK;mda(ok),web(without_reminder),tb(without_reminder)

I hope it's help. I love this project.
(0002082)
jaywalker (reporter)
2011-02-03 14:07

Has some progress been achieved on this bug? I still would love to use SOGo, but need a reliably working event synchronization with my mobile...
(0003594)
jaywalker (reporter)
2012-03-18 07:16

I tested today again with the connector version attached to this bug. Reminders are transferred correctly from the server to the phone.
Things get broken when transferring events from the phone back to the server, this is likely bug 586. However, KDEs kontact (via caldav access) states that the event from the mobile has a reminder "at the end of the event" set.

I encountered another problem, though: Non recurring events created or edited on the mobile cannot be edited via KDE kontact (caldav access) after syncing them to the server. Instead, kontact states "unknown error" and some error message saying that only resources could edit this event.
The event can be edited through the web interface without problems.

- Issue History
Date Modified Username Field Change
2010-05-27 21:09 wcronen New Issue
2010-05-28 05:45 havardw Note Added: 0001060
2010-05-28 15:32 wcronen Note Added: 0001066
2010-06-02 19:13 wcronen Note Added: 0001090
2010-09-14 13:38 jaywalker Note Added: 0001440
2010-09-14 14:32 wcronen Note Added: 0001442
2010-11-10 12:19 ludovic Note Added: 0001751
2010-11-11 15:55 ludovic Note Added: 0001770
2010-11-12 09:05 ludovic Note Added: 0001779
2010-11-12 09:05 ludovic Status new => feedback
2010-11-12 12:00 jaywalker Note Added: 0001784
2010-11-12 12:02 ludovic File Added: funambol-sogo-1.0.8.s4j
2010-11-12 12:02 ludovic Note Added: 0001786
2010-11-12 13:33 wcronen Note Added: 0001787
2010-11-13 03:23 jaywalker Note Added: 0001796
2010-11-13 07:52 ludovic Note Added: 0001797
2010-11-13 08:26 jaywalker Note Added: 0001798
2010-11-16 13:49 ludovic Note Added: 0001843
2010-11-17 18:01 wcronen Note Added: 0001864
2010-11-17 18:04 ludovic Note Added: 0001865
2010-11-22 14:28 wcronen Note Added: 0001885
2010-11-25 10:07 dusanl Note Added: 0001895
2010-11-25 15:20 wcronen Note Added: 0001898
2010-11-29 11:44 dusanl File Added: sogo-sync-edit.xls
2010-11-29 11:44 dusanl Note Added: 0001900
2011-02-03 14:07 jaywalker Note Added: 0002082
2011-02-08 18:40 ludovic Relationship added has duplicate 0001127
2011-07-22 13:20 jaywalker Note Added: 0002736
2011-10-09 14:33 jaywalker Note Deleted: 0002736
2011-12-22 12:54 francis Relationship added has duplicate 0000877
2011-12-22 12:54 francis Relationship added has duplicate 0001375
2011-12-22 12:55 francis Relationship added has duplicate 0000586
2012-03-18 07:16 jaywalker Note Added: 0003594
2012-08-27 16:42 ludovic Relationship added has duplicate 0000825


Copyright © 2000 - 2019 MantisBT Team
Powered by Mantis Bugtracker